/*
* ============================================================================
*  Name     : CContextNoteApp from ContextNoteApp.h
*  Part of  : ContextNote
*  Created  : 16.7.2004 by 
*  Description:
*     Declares main application class.
*  Version  :
*  Copyright: 
* ============================================================================
*/

#ifndef CONTEXTNOTEAPP_H
#define CONTEXTNOTEAPP_H

// INCLUDES
#include <aknapp.h>

// CONSTANTS
// UID of the application
#include <context_uids.h>

// CLASS DECLARATION

/**
* CContextNoteApp application class.
* Provides factory to create concrete document object.
* 
*/
class CContextNoteApp : public CAknApplication
    {
    
    public: // Functions from base classes
    private:

        /**
        * From CApaApplication, creates CContextNoteDocument document object.
        * @return A pointer to the created document object.
        */
        CApaDocument* CreateDocumentL();
        
        /**
        * From CApaApplication, returns application's UID (KUidContextNote).
        * @return The value of KUidContextNote.
        */
        TUid AppDllUid() const;
    };

#endif

// End of File

