/* 
    Copyright (C) 2004  Mika Raento - Renaud Petit

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


    email: mraento@cs.helsinki.fi - petit@cs.helsinki.fi 
*/


/*
* ============================================================================
*  Name     : CContext_logDocument from Context_logDocument.h
*  Part of  : context_log
*  Created  : 13.2.2003 by 
*  Description:
*     Declares document for application.
*  Version  :
*  Copyright: 
* ============================================================================
*/

#ifndef CONTEXT_LOGDOCUMENT_H
#define CONTEXT_LOGDOCUMENT_H

// INCLUDES
#include <akndoc.h>
#include "app_context.h"
#include "cl_settings.h"
   
// CONSTANTS

// FORWARD DECLARATIONS
class  CEikAppUi;

// CLASS DECLARATION

/**
*  CContext_logDocument application class.
*/
class CContext_logDocument : public CAknDocument
    {
    public: // Constructors and destructor
        /**
        * Two-phased constructor.
        */
        static CContext_logDocument* NewL(CEikApplication& aApp);

        /**
        * Destructor.
        */
        virtual ~CContext_logDocument();

    public: // New functions

    protected:  // New functions

    protected:  // Functions from base classes

    private:

        /**
        * EPOC default constructor.
        */
        CContext_logDocument(CEikApplication& aApp);
        void ConstructL();

    private:

        /**
        * From CEikDocument, create CContext_logAppUi "App UI" object.
        */
        CEikAppUi* CreateAppUiL();
	CApp_context* iContext;
	TClSettings iDefaultSettings;
    };

#endif

// End of File

